#ifndef _CONFIG_H
#define _CONFIG_H

#include "autoconf.h"

/* stuff */
#define AG_REDIRECT_SERVER	"garlic.audiogalaxy.com"
#define AG_CLIENT_VERSION	"0.609W"

#define MAX_FT				20		/* maximum number of concurrent downloads/uploads */
#define TRANSBUF			16384	/* file transfer buffer size */
#define TRANSTIMEOUT		90		/* file transfer/connect timeout */
#define PINGFREQ			30		/* ping frequency in seconds */
#define CONNTIMEOUT			20		/* server connect timeout in seconds */
#define DBSAVE_MININT		120		/* minimum time in seconds between sharedb saves */
#define MAX_PATH			256		/* max path length - 256 should be more than enough */
#define MAX_DEPTH			20		/* max depth for share_dir() */


/* platform dependant stuff */
#if (SIZEOF_CHAR != 1)
#	error "sizeof(char) is not 1 - FAGS won't work."
#endif

/* try to find a 2 byte(octet) long signed integer */
#if (SIZEOF_SHORT == 2)
	typedef short int16;
	typedef unsigned short uint16;
#else

#if (SIZEOF_INT == 2)
	typedef int int16;
	typedef unsigned int uint16;
#else

#if (SIZEOF_LONG == 2)
	typedef long int16;
	typedef unsigned long uint16;
#else
#	error "Could not find a 2 byte(octet) long signed integer"
#endif

#endif
#endif

/* try to find a 4 byte(octet) long signed integer */
#if (SIZEOF_INT == 4)
	typedef int int32;
	typedef unsigned int uint32;
#else

#if (SIZEOF_LONG == 4)
	typedef long int32;
	typedef unsigned long uint32;
#else

#if (SIZEOF_LONG_LONG == 4)
	typedef long long int32;
	typedef unsigned long long uint32;
#else
#	error "Could not find a 4 byte(octet) long signed integer"
#endif

#endif
#endif


/* used in most source files */
#ifdef HAVE_UNISTD_H
#	include <unistd.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <time.h>
#include <sys/time.h>
#ifndef HAVE_SNPRINTF
#	include "snprintf.h"
#endif
#ifndef HAVE_STRERROR
#	include "strerror.h"
#endif
#include "wrappers.h"
#include "event.h"

extern int running;
extern int status;

#define AG_STAT_DISCONNECTED	0	/* fetching server from redirect server */
#define AG_STAT_CONNECTING		1	/* connecting to ag server (not the redirect server) */
#define AG_STAT_CONNECTED		2	/* connected */
#define AG_STAT_SEND_SHARES		3	/* sending shares */
#define AG_STAT_LOGGED_IN		4	/* logged in */

#endif
