#include "config.h"

uint32 crc32tbl[256];


void make_crc32tbl(void)
{
	uint32 crc;
	int i, j;

	for(i=0;i<256;i++)
	{
		crc = i << 24;
		for(j=0;j<8;j++)
		{
			if(crc & 0x80000000)
				crc = (crc << 1) ^ 0x04C11DB7;
			else
				crc = crc << 1;
		}
		crc32tbl[i] = crc;
	}
	return;
}



uint32 crc32(unsigned char *str)
{
	uint32 crc;

	if(!*str)
		return 0;

	crc = *str++ << 24;
	if(*str)
		crc |= *str++ << 16;
	if(*str)
		crc |= *str++ << 8;
	if(*str)
		crc |= *str++;
	/*result = ~result;*/

	while(*str)
		crc ^= (crc << 8 | *str++) ^ crc32tbl[crc >> 24];

	return crc;	/* ~crc */
}

