#include "config.h"
#include "macros.h"
#include "md5.h"
#include <netinet/in.h>


/*
	rfc_tolowertab && rfc_touppertab are copied from the eggdrop source
	The original code was written by Otto Harkoonen. :)

	modified not to change [], {} etc..
*/

unsigned char to_lower[] = {
	0, 0x1, 0x2, 0x3, 0x4, 0x5, 0x6, 0x7, 0x8, 0x9, 0xa,
	0xb, 0xc, 0xd, 0xe, 0xf, 0x10, 0x11, 0x12, 0x13, 0x14,
	0x15, 0x16, 0x17, 0x18, 0x19, 0x1a, 0x1b, 0x1c, 0x1d,
	0x1e, 0x1f,
	' ', '!', '"', '#', '$', '%', '&', 0x27, '(', ')',
	'*', '+', ',', '-', '.', '/',
	'0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
	':', ';', '<', '=', '>', '?',
	'@', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i',
	'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's',
	't', 'u', 'v', 'w', 'x', 'y', 'z', '[', '\\', ']', '^',
	'_',
	'`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i',
	'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's',
	't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~',
	0x7f,
	0x80, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89,
	0x8a, 0x8b, 0x8c, 0x8d, 0x8e, 0x8f,
	0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98, 0x99,
	0x9a, 0x9b, 0x9c, 0x9d, 0x9e, 0x9f,
	0xa0, 0xa1, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, 0xa7, 0xa8, 0xa9,
	0xaa, 0xab, 0xac, 0xad, 0xae, 0xaf,
	0xb0, 0xb1, 0xb2, 0xb3, 0xb4, 0xb5, 0xb6, 0xb7, 0xb8, 0xb9,
	0xba, 0xbb, 0xbc, 0xbd, 0xbe, 0xbf,
	0xc0, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7, 0xc8, 0xc9,
	0xca, 0xcb, 0xcc, 0xcd, 0xce, 0xcf,
	0xd0, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7, 0xd8, 0xd9,
	0xda, 0xdb, 0xdc, 0xdd, 0xde, 0xdf,
	0xe0, 0xe1, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9,
	0xea, 0xeb, 0xec, 0xed, 0xee, 0xef,
	0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 0xf8, 0xf9,
	0xfa, 0xfb, 0xfc, 0xfd, 0xfe, 0xff
	};

unsigned char to_upper[] = {
	0, 0x1, 0x2, 0x3, 0x4, 0x5, 0x6, 0x7, 0x8, 0x9, 0xa,
	0xb, 0xc, 0xd, 0xe, 0xf, 0x10, 0x11, 0x12, 0x13, 0x14,
	0x15, 0x16, 0x17, 0x18, 0x19, 0x1a, 0x1b, 0x1c, 0x1d,
	0x1e, 0x1f,
	' ', '!', '"', '#', '$', '%', '&', 0x27, '(', ')',
	'*', '+', ',', '-', '.', '/',
	'0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
	':', ';', '<', '=', '>', '?',
	'@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I',
	'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S',
	'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', '\\', ']', '^',
	'_',
	'`', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I',
	'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S',
	'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '{', '|', '}', '~',
	0x7f,
	0x80, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89,
	0x8a, 0x8b, 0x8c, 0x8d, 0x8e, 0x8f,
	0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98, 0x99,
	0x9a, 0x9b, 0x9c, 0x9d, 0x9e, 0x9f,
	0xa0, 0xa1, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, 0xa7, 0xa8, 0xa9,
	0xaa, 0xab, 0xac, 0xad, 0xae, 0xaf,
	0xb0, 0xb1, 0xb2, 0xb3, 0xb4, 0xb5, 0xb6, 0xb7, 0xb8, 0xb9,
	0xba, 0xbb, 0xbc, 0xbd, 0xbe, 0xbf,
	0xc0, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7, 0xc8, 0xc9,
	0xca, 0xcb, 0xcc, 0xcd, 0xce, 0xcf,
	0xd0, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7, 0xd8, 0xd9,
	0xda, 0xdb, 0xdc, 0xdd, 0xde, 0xdf,
	0xe0, 0xe1, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9,
	0xea, 0xeb, 0xec, 0xed, 0xee, 0xef,
	0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 0xf8, 0xf9,
	0xfa, 0xfb, 0xfc, 0xfd, 0xfe, 0xff
	};

	
#ifdef USE_MALLOC_DEBUG

#include "malloc_debug.c"

#else

void *_ag_malloc(int size, unsigned char *file, int line)
{
	static void *ptr;

	if(size > 32768)
		return NULL;

	ptr = malloc(size);
	if(!ptr)
		NOTICE("Unable to allocate memory: %s (at %s:%d)", ERRMSG(), file, line);

	return ptr;
}


void _ag_free(void *ptr, unsigned char *file, int line)
{
	if(!ptr)
	{
		NOTICE("Tried to free() NULL ptr! (at %s:%d)", file, line);
		return;
	}
	free(ptr);

	return;
}


unsigned char *_ag_strdup(const unsigned char *s, unsigned char *file, int line)
{
	unsigned char *ptr;

	if(!s)
	{
		NOTICE("Tried to strdup() NULL ptr! (at %s:%d)", file, line);
		return NULL;
	}

	ptr = strdup(s);
	if(!ptr)
	{
		NOTICE("Unable to strdup(): %s (at%s:%d)", ERRMSG(), file, line);
		return NULL;
	}

	return ptr;
}

#endif

/*
	libc gayness - I quote:
	"if there is no  null byte among the first n bytes of src, the result will not be null-terminated."
*/
unsigned char *ag_strncpy(unsigned char *dst, const unsigned char *src, int n)
{
	strncpy(dst, src, n);
	if(n)
		dst[n-1] = 0;
	else
		dst[0] = 0;

	return dst;
}


unsigned char *MD5(const unsigned char *str, int len)
{
	md5_state_t pms;
	static unsigned char md5sum[17];

	md5_init(&pms);
	md5_append(&pms, str, len);
	md5_finish(&pms, md5sum);
	md5sum[16] = 0;

	return md5sum;
}


unsigned char *float2str(float v)
{
	static unsigned char str[32];

	snprintf(str, sizeof(str), "%.2f", v);
	return str;
}


unsigned char *int2str(int v)
{
	static unsigned char str[32];

	snprintf(str, sizeof(str), "%d", v);
	return str;
}


/* preappends "~/.fags/" to a string */
unsigned char *etc_file(unsigned char *path)
{
	static unsigned char file[MAX_PATH];
	unsigned char *home;

	home = getenv("HOME");

	if(snprintf(file, sizeof(file), "%s/.fags/%s", home?home:(unsigned char*)".", path) == -1)
	{
		NOTICE("Path too long!");
		return NULL;
	}

	return file;
}


/* checks if a file exists :)  (perhaps I should use stat() instead) */
int file_exists(unsigned char *str)
{
	FILE *fd;

	fd = fopen(str, "r");
	if(!fd && errno == ENOENT)	/* file doesn't exist */
		return 0;

	if(fd)
		fclose(fd);

	return 1;
}


/* divides a with b and rounds the result - written by arachnid, the math professor :) */
int rdiv(int a, int b)
{
	int v = 0;

	if(b == 0)
		return 0;

	v = a / b;

	if(b % 2)
	{
		if((a % b) >= ((b / 2) + 1))
			v++;
	}
	else if((a % b) >= (b / 2))
	{
		v++;
	}

	return v;
}


void capitalize_filename(unsigned char *filename)
{
	unsigned char *tmp,*ptr;
	int cap=1,last_dot=0,p=0;

	tmp = strrchr(filename, '.');
	if(tmp)
		last_dot = (int)(tmp - filename);

	ptr = filename;
	while(*ptr)
	{
		/* dont capitalize file extension (but make it lowercase!) */
		if(last_dot && p > last_dot)
			cap = 0;

		if(cap)
			*ptr = to_upper[*ptr];
		else
			*ptr = to_lower[*ptr];

		/* capitalize after these chars.. */
		if(strchr("({[]})-_&. " , *ptr))
			cap = 1;
		else
			cap = 0;

		p++;
		ptr++;
	}

	/*ptr = filename;*/
	/* TODO: make abbreviations uppercase */

	return;
}


int16 ag_ptr_int16(const unsigned char *ptr)
{
	static int16 v;

	v = (ptr[0] * 256) + ptr[1];

	return v;
}

int32 ag_ptr_int32(const unsigned char *ptr)
{
	static int32 v;

	v = (ptr[0] * 16777216) + (ptr[1] * 65536) + (ptr[2] * 256) + ptr[3];

	return v;
}


unsigned char *ag_int16_ptr(const int16 _v)
{
	static unsigned char ptr[2];
	static int16 v;

	v = ntohs(_v);
	memcpy(ptr, &v, 2);

	return ptr;
}

unsigned char *ag_int32_ptr(const int32 _v)
{
	static unsigned char ptr[4];
	static int32 v;

	v = ntohl(_v);
	memcpy(ptr, &v, 4);

	return ptr;
}

